// The Game of BlackJack
// By Michael Cripps

class blackjackGame extends CardGame
{
	int nextplayer;
	int inc;
	Card lastCard;
	
	public blackjackGame(IRCEventHandler ircEvents)
	{
		super(ircEvents);
		nextplayer = 0;
		inc=1;
	}

	void play(String nick, String target, String[] args)
	{
           // remove a card, and declare it played
           if (hands==null) {
              ircEvents.sendPrivMessage(target,"Please deal first");
              return;
           }
           if (players.contains(nick)) {
              if (!nick.equals(players.get(nextplayer))) {
                 ircEvents.sendPrivMessage(target,"It is not your turn!");
              } else {
                 int player = players.indexOf(nick);
                 Card card = null;
                 try {
                    card = new Card(args[0]);
                 } catch (CardParseException e) {
                    ircEvents.sendPrivMessage(target,"Invalid Card");
                    return;
                 }
                 if (hands[player].contains(card)) {
                    if (card.suit() != lastCard.suit() && card.number() != lastCard.number() && card.number() != 14) {
                       ircEvents.sendPrivMessage(target,"Invalid Card!");
                    } else {
                       hands[player].remove(card);
                       ircEvents.sendPrivMessage(target,nick +" played the "+ card.toString());
                       if (card.number() == 7) inc *= -1;
                       nextplayer += ((card.number()==8)?2:1)*inc;
                       nextplayer %= players.size();
                       lastCard = card;
                    }
                 } else ircEvents.sendPrivMessage(target,"You don't have that card");            	
              }
           } else ircEvents.sendPrivMessage(target,"You are not a player");
        }
        
   public void parse(String nick, String target, String command, String[] args)
   {
      if (command.equals("HELP")) {
         help(nick);
         
      } else if (command.equals("GAME")) {
         game(target, args);

      } else if (command.equals("RESET")) {
         reset();
                  
      } else if (command.equals("DECK")) {
         deck(target, args);         
            
      } else if (command.equals("PLAYER")) {
         player(target, args);
         
      } else if (command.equals("DEAL")) {
         deal(nick, target, args);
         try {
            ircEvents.sendPrivMessage(target,"The turnup card is the " + (lastCard=deck.next()));
            ircEvents.sendPrivMessage(target,players.get(nextplayer)+"'s turn first");
         } catch (InsufficientCardsException e) {
            ircEvents.sendPrivMessage(target,"There are not enough cards to turn up");
         }

      } else if (command.equals("HAND")) {
         hand(nick, target, args);
         
      } else if (command.equals("PLAY")) {
         play(nick, target, args);
         
      } else ircEvents.sendPrivMessage(target,"Bad Command");
   }
}
